//Script by Amade, model by Pi

%error = ForceRequiredAddOn("Weapon_Gun");
if(%error == $Error::AddOn_Disabled)
{
   gunItem.uiName = "";
}

datablock AudioProfile(PiAK47ShotSound)
{
   filename    = "add-ons/Weapon_Gun/gunShot1.wav";
   description = AudioClose3d;
   preload     = true;
};

AddDamageType("PiAK47", '<bitmap:add-ons/Weapon_PiAK-47/PiAK47_CI> %1', '%2 <bitmap:add-ons/Weapon_PiAK-47/PiAK47_CI> %1',0.2,1);

datablock ProjectileData(PiAK47Projectile : gunProjectile)
{
   directDamage     = 15;
   directDamageType = $DamageType::PiAK47;
   radiusDamageType = $DamageType::PiAK47;
   impactImpulse    = 100;
   verticalImpulse  = 10;
   muzzleVelocity   = 100;
   velInheritFactor = 1;
   uiName           = "Ak-47 Bullet";
};

datablock ItemData(PiAK47Item : GunItem)
{
   shapeFile       = "./PiAK.dts";
   uiName          = "AK-47";
   iconName        = "./PiAK47_Icon";
   doColorShift    = false;
   colorShiftColor = "0 0 0 1";

   image   = PiAK47Image;
   canDrop   = true;
};

datablock ShapeBaseImageData(PiAK47Image : GunImage)
{
   shapeFile  = "./PiAK.dts";
   projectile = PiAK47Projectile;

   doColorShift    = PiAK47Item.doColorShift;
   colorShiftColor = PiAK47Item.colorShiftColor;

   stateName[0]                   = "Activate";
   stateTimeoutValue[0]           = 0.15;
   stateTransitionOnTimeout[0]    = "Ready";
   stateSound[0]                  = weaponSwitchSound;

   stateName[1]                   = "Ready";
   stateTransitionOnTriggerDown[1]= "Fire";
   stateAllowImageChange[1]       = true;
   stateSequence[1]               = "Ready";

   stateName[2]                   = "Fire";
   stateTransitionOnTimeout[2]    = "Reload";
   stateTimeoutValue[2]           = 0.125;
   stateFire[2]                   = true;
   stateAllowImageChange[2]       = false;
   stateSequence[2]               = "Fire";
   stateScript[2]                 = "onFire";
   stateWaitForTimeout[2]         = true;
   stateEmitter[2]                = gunFlashEmitter;
   stateEmitterTime[2]            = 0.05;
   stateEmitterNode[2]            = "muzzleNode";
   stateSound[2]                  = PiAK47ShotSound;
   stateEjectShell[2]             = true;

   stateName[3]                   = "Smoke";
   stateEmitter[3]                = gunSmokeEmitter;
   stateEmitterTime[3]            = 0.5;
   stateEmitterNode[3]            = "muzzleNode";
   stateTimeoutValue[3]           = 0.01;
   stateTransitionOnTimeout[3]    = "Ready";

   stateName[4]                   = "Reload";
   stateSequence[4]               = "Reload";
   stateTransitionOnTriggerUp[4]  = "Smoke";
   stateTransitionOnTriggerDown[4]= "Fire";
   stateSequence[4]               = "Ready";
};

//Ephialtes' bullet spread coding
function PiAK47Image::onFire(%this, %obj, %slot)
{
   %spread = 0.00175;
   %projectile = %this.projectile;
   %vector = %obj.getMuzzleVector(%slot);
   %objectVelocity = %obj.getVelocity();
   %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
   %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
   %velocity = VectorAdd(%vector1,%vector2);
   %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
   %velocity = MatrixMulVector(%mat, %velocity);
   %p = new (%this.projectileType)()
   {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
   };
   MissionCleanup.add(%p);
}